
function addLabelsToTimeline(){
    var chartId = jQuery(".spjs_chartPlaceholder:first").attr("id");
    try{
        if(spjs.charts.data.charts[chartId].draw !== undefined){
            // Ready
        }else{
            setTimeout(function(){
                addLabelsToTimeline();
            },250);
            return;
        }
    }catch(ignore){
        setTimeout(function(){
            addLabelsToTimeline();
        },250);
        return;
    }
    var svg = jQuery("#"+chartId+"_chart").find("svg:last");
    var dataTable = spjs.charts.data.chartData[chartId];
    var rectangles = jQuery("rect");
    var ticker = 0;
    jQuery.each(rectangles,function(i,rect){
        if (jQuery(rect).attr("x") !== "0") {
            var fill = jQuery(rect).attr("fill");
            var txtColor = getCorrectTextColor(fill);
            var rectX = Number(jQuery(rect).attr("x"));
            var rectY = Number(jQuery(rect).attr("y"));
            var rectW = Number(jQuery(rect).attr("width"));
            var txtNode = document.createElementNS("http://www.w3.org/2000/svg", "text");
            txtNode.setAttributeNS(null, "text-anchor", "start");
            txtNode.setAttributeNS(null, "x", rectX+5);
            txtNode.setAttributeNS(null, "y",  rectY+12);
            txtNode.setAttributeNS(null, "font-size", 9);
            txtNode.setAttributeNS(null, "stroke", "none");
            txtNode.setAttributeNS(null, "stroke-width", 0);
            txtNode.setAttributeNS(null, "fill", txtColor);
            var txt = document.createTextNode(truncateText(dataTable.getValue(ticker, 1),rectW));
            txtNode.appendChild(txt);
            svg[0].appendChild(txtNode);
            ticker +=1;
        }
    });
}

function truncateText (str,width){
    var r = str.substring(0,(width/5)-3);
    if(r.length < 3){
        r = "";
    }else{
        if(str.length > r.length){
            r += "...";
        }
    }
    return r;
}

function getCorrectTextColor(hex){
	// From this W3C document: http://www.webmasterworld.com/r.cgi?f=88&d=9769&url=http://www.w3.org/TR/AERT#color-contrast
	var threshold = 135; /* about half of 256. Lower threshold equals more dark text on dark background  */

	var hRed = hexToR(hex);
	var hGreen = hexToG(hex);
	var hBlue = hexToB(hex);

	function hexToR(h) {return parseInt((cutHex(h)).substring(0,2),16);}
	function hexToG(h) {return parseInt((cutHex(h)).substring(2,4),16);}
	function hexToB(h) {return parseInt((cutHex(h)).substring(4,6),16);}
	function cutHex(h) {return (h.charAt(0)=="#") ? h.substring(1,7):h;}

	var cBrightness = ((hRed * 299) + (hGreen * 587) + (hBlue * 114)) / 1000;
	if (cBrightness > threshold){
		return "#000000";
	} else { 
		return "#ffffff";
	}	
}

setTimeout(function(){
    addLabelsToTimeline();
},250);